{% macro _menu_footer_multi_level(items, nav_id) %}
  {% if items %}
    {% set section_id = nav_id ~ "-section-" ~ loop_index %}
    {% set attributes = item.attributes|default({})|add_class(["usa-footer__primary-content", "usa-footer__primary-content--collapsible"]) %}
    {% set column_attributes = column_attributes|default({"class": ["tablet:grid-col-fill", "grid-col-auto"]}) %}
    {% for item in items %}
      <div {{ column_attributes }}>
        <section {{ attributes }}>
          {{ _menu_footer_sections(item, loop.index, nav_id) }}
        </section>
      </div>
    {% endfor %}
  {% endif %}
{% endmacro %}
{% macro _menu_footer_single_level(items, nav_id) %}
  {% if items %}
    {% set section_id = nav_id ~ "-section-" ~ loop_index %}
    {% set attributes = item.attributes|default({})|add_class(["usa-footer__primary-content", "usa-footer__primary-content--collapsible"]) %}
    {% set column_attributes = column_attributes|default({"class": "grid-col-auto"}) %}
    <ul class="grid-row grid-gap">
      {% for item in items %}{{ _footer_menu_link(item) }}{% endfor %}
    </ul>
  {% endif %}
{% endmacro %}
{% macro _menu_footer_sections(item, loop_index, nav_id, first_level_only) %}
  {% set header_attributes = item.link_attributes|default({})|add_class("usa-footer__primary-link") %}
  <h4 {{ header_attributes }}>{{ item.title }}
  </h4>
  {% if item.below %}{{ _submenu_simple(item.below, section_id) }}{% endif %}
{% endmacro %}
{% macro _submenu_simple(items, section_id) %}
  <ul id="{{ section_id }}" class="usa-list usa-list--unstyled">
    {% for item in items %}{{ _submenu_link(item) }}{% endfor %}
  </ul>
{% endmacro %}
{% macro _submenu_link(item) %}
  {% set attributes = item.attributes|default({})|add_class("usa-footer__secondary-link") %}
  {% set link_attributes = item.link_attributes|default({}) %}
  {% set link_attributes = link_attributes|set_attribute("href", item.url) if item.url else link_attributes %}
<li {{ attributes }}><a {{ link_attributes }}>{{ item.title }}</a>
</li>
{% endmacro %}
{% macro _footer_menu_link(item) %}
  {% set link_attributes = item.link_attributes|default({})|add_class("usa-footer__primary-link") %}
  {% set link_attributes = link_attributes|set_attribute("href", item.url) if item.url else link_attributes %}
  {% set column_attributes = column_attributes|default({"class": ["grid-col-auto", "usa-footer__primary-content"]}) %}
<li {{ column_attributes }}><a {{ link_attributes }}>{{ item.title }}</a>
</li>
{% endmacro %}
{% set nav_id = "usa-nav-" ~ nav_id|default(random()) %}
<nav {{ attributes|add_class("usa-footer__nav") |set_attribute("role", "navigation") }}>
  {% if first_level_only %}
    {{ _menu_footer_single_level(footer, nav_id) }}
  {% else %}
    <div class="grid-row grid-gap-4">{{ _menu_footer_multi_level(footer, nav_id) }}</div>
  {% endif %}
</nav>
